<?php

define('IN_COPPERMINE', true);

require('include/init.inc.php');
pageheader($lang_admin_data[0]);
?>
<h1>Guess the picture game - Instructions</h1>

<p>The guess game is a plugin for awarding points to a leader board for the correct answer to a picture.</p>

<p>Although the game can be used for many things it was developed for a mystery picture section, whereby members can upload mystery pictures to a predefined album and place a question in the title of the picture, like where is this mystery picture of? Other members, the guessers, can guess its location by placing their guesses in the comments section below that picture.<br />
Once a member has correctly guesses the picture the member who uploaded the picture can award points (predefined amount of points) to the correct guesser from the dropdown list of the guessers. The mystery picture will then have the winners username displayed beneath along with the amount of points awarded. A leader board is also available to show all members who is at the top of the league.</p>


<h3>Here's how to use the plugin</h3>

<p>Once installed go to the config section of your Coppermine gallery (remember you'll need to be in administrator mode to do this). At the bottom of the config section is the Guess game control
panel. Here you have two options:</p>
<ul>
	<li><h4>Award points</h4>
	Enter the amount of points you wish to
	award (you cannot enter1/5 or .5 and so on only full decimals)</li>
	<li><h4>Award album</h4>
	Enter the album number you wish the game to operate within. You can have more than one album and the album numbers would be separated by a comma (example 491,566,741 and so on) but you will only have one leader board. There is no need for the comma if you are using one album.</li>
</ul>

<h3>Points manager:</h3>
You'll notice that you have a point's manager in the main menu of Coppermine (only available to administrators). This is to correct mistakes, add further points, remove points, delete entry or look up awards. The awards are showing with the latest award first.</p>


<h3>Here how it all works.</h3>

<h4>Enter user ID:</h4>
<p>This is a search box to help you find awards that have already been given to a certain member. Simply type the user name of the member in the box to reveal their awards.</p>

<h4>Display:</h4>
<p>Here you can choose from the amount of entries you would like to see from the results of the above search. You can choose 10, 20 or more.</p>

<h4>Image:</h4>
<p>Once points have been awarded the points manager will become populated with the information on who won what. On the left hand side is the gallery. By clicking on this it shows the picture that was guessed correctly by that user. This is handy as a reference.</p>

<h4>User:</h4>
<p>This show the user name who was awarded the points</p>

<h4>Point</h4>
This column shows the points that have been awarded for that correct guess</p>

<h4>Modify</h4>
<p>By clicking on modify you can alter the points that have already been awarded. Normally you would only use this for adding or removing points. Remember you can only use full points and not &frac12; or .5 When you have
done click the edit to save changes. Remember that what changes you make here show up underneath the awarded picture. So if you change the awarded points from 5 to 10, then this will show as 10 beneath the awarded picture from then on.</p>

<h4>Delete:</h4>
<p>This is used when an award was given by mistake. Click the delete button at the end of the award you want removing. Be aware that there is no warning after you click delete… it is then removed. The member who uploaded
the picture can now award the points again.</p>


<p>At the bottom of the points managers are the available pages. By clicking on these you will go to the page showing the awards.</p>

<h3>Leader board:</h3>
<p>All the points are totalled up and added to the leader board. This board is available to all members. There is only one leader board, so if you are running more than one game all the points are shown here by member and points. The leader is at the top. There is only one button and this shows the top 20 leaders or click again to show all the participating members.</p>

<h2>How to play:</h2>

<p>Upload the picture you want guessed into the album you chose earlier. So long as the picture was uploaded to the correct album you will see a button named award beneath the title area of the picture.</p>

<p>All other members regardless of their higher Archie will see the words “no one win this the game yet !” until the awards have been given.</p>

<p>If you've chosen to use an album in the main gallery make sure that members have the right to upload to this section buy allowing upload rights in the usual way. Also make sure that the album isn't private or protected for obvious reasons.</p>

<p>Members will place their guesses in the comments section beneath the picture until someone guesses correctly. The member who uploaded the picture can then click the award button and choose from the list a member to award the points to. The list only contains the members who have commented and does not show the member who uploaded the picture. This is by design to prevent the up loader from awarding points to themselves after making a comment.</p>

<p>Once points have been awarded the members name is displayed beneath the picture description along with the amount of points awarded. This way members know that the game is up.</p>
<?php

pagefooter();
?>